<div class="row justify-content-center">
  <div class="col-12">
    <form [formGroup]="snmpSetting">
      <div class="card p-0">
        <div class="card-header">
          {{'log_forward.snmp.title' | translate}}
        </div>
        <div class="card-body">
          <div class="row">
            <!-- System Info -->
            <div class="col-12">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.sys_info' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <!-- Enable -->
                    <div class="col-2 py-1">
                      {{'log_forward.snmp.config_status' | translate}}
                    </div>
                    <div class="col-10 py-1 d-flex align-items-center">
                      <label class="switch switch-pill switch-success mb-0">
                        <input type="checkbox" class="switch-input" checked formControlName="config_status"
                          (change)="checkForm($event)">
                        <span class="switch-slider"></span>
                      </label>
                    </div>

                    <!-- Description -->
                    <div class="col-2 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.description' | translate}}
                      </div>
                    </div>
                    <div class="col-10 py-1 d-flex align-items-center">
                      <input type="text" class="form-control" formControlName="description"
                        placeholder="{{'log_forward.snmp.description' | translate}}" required
                        [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null" />
                      <!--                      <div-->
                      <!--                        *ngIf="snmpSetting.get('description').invalid && snmpSetting.get('description').dirty || snmpSetting.get('description').touched">-->
                      <!--                                <span class="form-text text-danger"-->
                      <!--                                      *ngIf="snmpSetting.get('description').touched && snmpSetting.get('description').errors?.required">-->
                      <!--                                  {{'log_forward.snmp.errors.requiredPort' | translate}}-->
                      <!--                                </span>-->
                      <!--                        <span class="form-text text-danger"-->
                      <!--                              *ngIf="snmpSetting.get('description').touched && snmpSetting.get('description').errors?.pattern">-->
                      <!--                                  {{'log_forward.snmp.errors.invalidPort' | translate}}-->
                      <!--                                </span>-->
                      <!--                      </div>-->
                    </div>

                    <!-- Location -->
                    <div class="col-2 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.location' | translate}}
                      </div>
                    </div>
                    <div class="col-10 py-1 d-flex align-items-center">
                      <input type="text" class="form-control" formControlName="location"
                        placeholder="{{'log_forward.snmp.location' | translate}}" required
                        [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null" />
                      <!--                      <div-->
                      <!--                        *ngIf="snmpSetting.get('location').invalid && snmpSetting.get('location').dirty || snmpSetting.get('location').touched">-->
                      <!--                                <span class="form-text text-danger"-->
                      <!--                                      *ngIf="snmpSetting.get('location').touched && snmpSetting.get('location').errors?.required">-->
                      <!--                                  {{'log_forward.snmp.errors.requiredPort' | translate}}-->
                      <!--                                </span>-->
                      <!--                        <span class="form-text text-danger"-->
                      <!--                              *ngIf="snmpSetting.get('location').touched && snmpSetting.get('location').errors?.pattern">-->
                      <!--                                  {{'log_forward.snmp.errors.invalidPort' | translate}}-->
                      <!--                                </span>-->
                      <!--                      </div>-->
                    </div>

                    <!-- Contact Info -->
                    <div class="col-2 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.contact_info' | translate}}
                      </div>
                    </div>
                    <div class="col-10 py-1 d-flex align-items-center">
                      <input type="text" class="form-control" formControlName="contact_info"
                        placeholder="{{'log_forward.snmp.contact_info' | translate}}" required
                        [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null" />
                      <!--                      <div-->
                      <!--                        *ngIf="snmpSetting.get('contact_info').invalid && snmpSetting.get('contact_info').dirty || snmpSetting.get('contact_info').touched">-->
                      <!--                                <span class="form-text text-danger"-->
                      <!--                                      *ngIf="snmpSetting.get('contact_info').touched && snmpSetting.get('contact_info').errors?.required">-->
                      <!--                                  {{'log_forward.snmp.errors.requiredPort' | translate}}-->
                      <!--                                </span>-->
                      <!--                        <span class="form-text text-danger"-->
                      <!--                              *ngIf="snmpSetting.get('contact_info').touched && snmpSetting.get('contact_info').errors?.pattern">-->
                      <!--                                  {{'log_forward.snmp.errors.invalidPort' | translate}}-->
                      <!--                                </span>-->
                      <!--                      </div>-->
                    </div>

                  </div>
                </div>
              </div>
            </div>

            <!-- SNMP v1/v2c -->
            <div class="col-12">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.title' | translate}}
                  <div class="card-header-actions">
                    <button type="button" class="btn btn-primary"
                      [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null"
                      (click)="openAddSnmpv1v2Modal(addSnmpv1v2Modal)">{{'log_forward.snmp.add' | translate}}</button>
                  </div>
                </div>
                <div class="card-body">
                  <table class="table table-bordered table-sort-icon">
                    <thead>
                      <tr>
                        <th>{{'log_forward.snmp.snmp_v1v2c.name' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.queries' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.traps' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.hosts' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.events' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.status' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.actions' | translate}}</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr *ngFor="let snmp of snmpSetting.get('snmp').value; let snmpIdx = index">
                        <td>{{snmp.name}}</td>
                        <td>
                          v1 {{snmp.queries.v1 ? 'Enabled' : 'Disabled'}} v2 {{snmp.queries.v2 ? 'Enabled' :
                          'Disabled'}}
                        </td>
                        <td>
                          v1 {{snmp.traps.v1 ? 'Enabled' : 'Disabled'}} v2 {{snmp.traps.v2 ? 'Enabled' : 'Disabled'}}
                        </td>
                        <td>
                          {{snmp.hosts}}
                        </td>
                        <td>
                          {{snmp.events}}
                        </td>
                        <td class="text-center">
                          {{snmp.status ? 'Enabled' : 'Disabled'}}
                        </td>
                        <td class="text-center">
                          <button type="button" class="btn btn-sm btn-info"
                            [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null"
                            (click)="openEditSnmpCommunityEdit(addSnmpv1v2Modal, snmp.name)">{{'log_forward.snmp.edit' |
                            translate}}</button>
                          <button type="button" class="btn btn-sm btn-danger"
                            [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null"
                            (click)="deleteSnmpCommunity(deleteSnmpv1v2Modal, snmp.name)">{{'log_forward.snmp.delete' |
                            translate}}</button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
            </div>

            <!-- SNMP v3 -->
            <div class="col-12">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v3.title' | translate}}
                  <div class="card-header-actions">
                    <button type="button" class="btn btn-primary"
                      [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null"
                      (click)="openAddSnmpv3Modal(addSnmpv3Modal)">{{'log_forward.snmp.add' | translate}}</button>
                  </div>
                </div>
                <div class="card-body">
                  <table class="table table-bordered table-sort-icon">
                    <thead>
                      <tr>
                        <th>{{'log_forward.snmp.snmp_v3.name' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v3.security_level' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v3.queries' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v3.traps' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v3.hosts' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v3.events' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v3.status' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v3.actions' | translate}}</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr *ngFor="let snmp_v3 of snmpSetting.get('snmp_v3').value; let snmp_v3Idx = index">
                        <td>{{snmp_v3.name}}</td>
                        <td>
                          {{snmp_v3.security_level.authentication ? ' Authentication ' : ''}}
                          {{snmp_v3.security_level.private ? ' Private ' : ''}}
                        </td>
                        <td>
                          {{snmp_v3.queries}}
                        </td>
                        <td>
                          {{snmp_v3.traps}}
                        </td>
                        <td>
                          {{snmp_v3.hosts}}
                        </td>
                        <td>
                          {{snmp_v3.events}}
                        </td>
                        <td>
                          {{snmp_v3.status ? 'Enabled' : 'Disabled'}}
                        </td>
                        <td class="text-center">
                          <button type="button" class="btn btn-sm btn-info"
                            [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null"
                            (click)="openEditSnmpCommunityV3Edit(addSnmpv3Modal, snmp_v3.name)">{{'log_forward.snmp.edit'
                            | translate}}</button>
                          <button type="button" class="btn btn-sm btn-danger"
                            [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null"
                            (click)="deleteSnmpCommunityV3(deleteSnmpv3Modal, snmp_v3.name)">{{'log_forward.snmp.delete'
                            | translate}}</button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
            </div>

            <!-- button save -->
            <div class="col-12">
              <div class="d-flex">
                <div class="flex-grow-1"></div>
                <!-- [attr.disabled]="!snmpSetting.get('config_status').value ? '' : null" -->
                <button type="button" class="btn btn-primary" (click)="confirmSave()">{{'log_forward.snmp.save' |
                  translate}}</button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </form>
  </div>
  <!-- Add/update SNMP Community -->
  <ng-template #addSnmpv1v2Modal let-modal>
    <form [formGroup]="addSnmpV1v2FormGroup" (ngSubmit)="saveSnmpSetting(modal)">
      <div>
        <div class="modal-header">
          <h4 class="modal-title" id="modal-add-snmp-v1-v2">{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.title' |
            translate }}</h4>
          <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body" style="max-height: calc(100vh - 200px); overflow-y: auto">
          <div class="row">
            <!-- Community Name -->
            <div class="col-3 py-1">
              <div class="mt-1">
                {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.community_name' | translate}}
              </div>
            </div>
            <div class="col-9 py-1">
              <input type="text" class="form-control" formControlName="community_name" pattern="^\w+$"
                placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.community_name' | translate}}"
                required />
              <div
                *ngIf="addSnmpV1v2FormGroup.get('community_name').invalid && addSnmpV1v2FormGroup.get('community_name').dirty || addSnmpV1v2FormGroup.get('community_name').touched">
                <span class="form-text text-danger"
                  *ngIf="addSnmpV1v2FormGroup.get('community_name').touched && addSnmpV1v2FormGroup.get('community_name').errors?.required">
                  {{'log_forward.snmp.errors.requiredCommunityName' | translate}}
                </span>
                <span class="form-text text-danger"
                  *ngIf="addSnmpV1v2FormGroup.get('community_name').touched && addSnmpV1v2FormGroup.get('community_name').errors?.pattern">
                  {{'log_forward.snmp.errors.invalidCommunityName' | translate}}
                </span>
              </div>
            </div>
            <!-- Enable -->
            <div class="col-3 py-1">
              {{'log_forward.snmp.config_status' | translate}}
            </div>
            <div class="col-9 py-1 d-flex align-items-center">
              <label class="switch switch-pill switch-success mb-0">
                <input type="checkbox" class="switch-input" checked formControlName="enable"
                  (change)="changeCommunityActiveStatus($event)">
                <span class="switch-slider"></span>
              </label>
            </div>
            <!-- Hosts -->
            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.title' | translate}}
                  <div class="card-header-actions">
                    <button type="button" class="btn btn-primary"
                      [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null"
                      (click)="openAddSnmpHost(addSnmpv1v2HostModal)">{{'log_forward.snmp.add' | translate}}</button>
                  </div>
                </div>
                <div class="card-body">
                  <table class="table table-bordered table-sort-icon">
                    <thead>
                      <tr>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.ip_address' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.netmask' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.host_type' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.actions' | translate}}</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr *ngFor="let host of addSnmpV1v2FormGroup.get('hosts').value; let hostIdx = index">
                        <td>{{host.ip_address}}</td>
                        <td>{{host.netmask}}</td>
                        <td class="text-center">
                          <button type="button"
                            [class]="!!host.accept_queries ? 'btn btn-sm btn-info' : 'btn btn-sm btn-secondary'">
                            Accept queries
                          </button>
                          <button type="button"
                            [class]="!!host.send_traps ? 'btn btn-sm btn-info' : 'btn btn-sm btn-secondary'">
                            Send traps
                          </button>
                        </td>
                        <td class="text-center">
                          <button type="button" class="btn btn-sm btn-info"
                            [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null"
                            (click)="openEditSnmpHost(addSnmpv1v2HostModal, host, hostIdx)">{{'log_forward.snmp.edit' |
                            translate}}</button>
                          <button type="button" class="btn btn-sm btn-danger"
                            [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null"
                            (click)="deleteSnmpHost(deleteSnmpv1v2HostModal, hostIdx)">{{'log_forward.snmp.delete' |
                            translate}}</button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
            </div>

            <!-- Queries -->
            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.title' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <!-- v1 Enable -->
                    <div class="col-3 py-1">
                      {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.v1_enabled' | translate}}
                    </div>
                    <div class="col-9 py-1 d-flex align-items-center">
                      <label class="switch switch-pill switch-success mb-0">
                        <input type="checkbox" class="switch-input" checked formControlName="v1_enabled"
                          [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null"
                          (change)="changeQueriesv1ActiveStatus($event)" />
                        <span class="switch-slider"></span>
                      </label>
                    </div>
                    <!-- v1 Port-->
                    <div class="col-3 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.port' | translate}}
                      </div>
                    </div>
                    <div class="col-9 py-1">
                      <input type="text" class="form-control" formControlName="v1_port"
                        pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                        placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.port' | translate}}"
                        required
                        [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value || !addSnmpV1v2FormGroup.get('v1_enabled').value">
                      <div
                        *ngIf="addSnmpV1v2FormGroup.get('v1_enabled').value && (addSnmpV1v2FormGroup.get('v1_port').invalid && addSnmpV1v2FormGroup.get('v1_port').dirty || addSnmpV1v2FormGroup.get('v1_port').touched)">
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV1v2FormGroup.get('v1_port').touched && addSnmpV1v2FormGroup.get('v1_port').errors?.required">
                          {{'log_forward.sys_log.errors.requiredPort' | translate}}
                        </span>
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV1v2FormGroup.get('v1_port').touched && addSnmpV1v2FormGroup.get('v1_port').errors?.pattern">
                          {{'log_forward.sys_log.errors.invalidPort' | translate}}
                        </span>
                      </div>
                    </div>

                    <!-- v2 Enable -->
                    <div class="col-3 py-1">
                      {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.v2_enabled' | translate}}
                    </div>
                    <div class="col-9 py-1 d-flex align-items-center">
                      <label class="switch switch-pill switch-success mb-0">
                        <input type="checkbox" class="switch-input" checked formControlName="v2_enabled"
                          [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null"
                          (change)="changeQueriesv2ActiveStatus($event)">
                        <span class="switch-slider"></span>
                      </label>
                    </div>
                    <!-- v2 Port-->
                    <div class="col-3 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.port' | translate}}
                      </div>
                    </div>
                    <div class="col-9 py-1">
                      <input type="text" class="form-control" formControlName="v2_port"
                        pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                        placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.port' | translate}}"
                        required
                        [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value || !addSnmpV1v2FormGroup.get('v2_enabled').value ? '' : null">
                      <div
                        *ngIf="addSnmpV1v2FormGroup.get('v2_enabled').value && (addSnmpV1v2FormGroup.get('v2_port').invalid && addSnmpV1v2FormGroup.get('v2_port').dirty || addSnmpV1v2FormGroup.get('v2_port').touched)">
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV1v2FormGroup.get('v2_port').touched && addSnmpV1v2FormGroup.get('v2_port').errors?.required">
                          {{'log_forward.sys_log.errors.requiredPort' | translate}}
                        </span>
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV1v2FormGroup.get('v2_port').touched && addSnmpV1v2FormGroup.get('v2_port').errors?.pattern">
                          {{'log_forward.sys_log.errors.invalidPort' | translate}}
                        </span>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- Traps -->
            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.title' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <div class="col-6">
                      <div class="row">
                        <!-- v1 Enable -->
                        <div class="col-3 py-1">
                          {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.v1_enabled' | translate}}
                        </div>
                        <div class="col-9 py-1 d-flex align-items-center">
                          <label class="switch switch-pill switch-success mb-0">
                            <input type="checkbox" class="switch-input" checked formControlName="v1_traps_enabled"
                              [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null"
                              (change)="changeTrapsv1ActiveStatus($event)">
                            <span class="switch-slider"></span>
                          </label>
                        </div>

                        <!-- v1 Local Port-->
                        <div class="col-3 py-1">
                          <div class="mt-1">
                            {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.local_port' | translate}}
                          </div>
                        </div>
                        <div class="col-9 py-1">
                          <input type="text" class="form-control" formControlName="v1_local_port"
                            pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                            placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.local_port' | translate}}"
                            required
                            [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value || !addSnmpV1v2FormGroup.get('v1_traps_enabled').value ? '' : null">
                          <div
                            *ngIf="addSnmpV1v2FormGroup.get('v1_traps_enabled').value && (addSnmpV1v2FormGroup.get('v1_local_port').invalid && addSnmpV1v2FormGroup.get('v1_local_port').dirty || addSnmpV1v2FormGroup.get('v1_local_port').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v1_local_port').touched && addSnmpV1v2FormGroup.get('v1_local_port').errors?.required">
                              {{'log_forward.sys_log.errors.requiredPort' | translate}}
                            </span>
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v1_local_port').touched && addSnmpV1v2FormGroup.get('v1_local_port').errors?.pattern">
                              {{'log_forward.sys_log.errors.invalidPort' | translate}}
                            </span>
                          </div>
                        </div>

                        <!-- v1 Remote Port-->
                        <div class="col-3 py-1">
                          <div class="mt-1">
                            {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.remote_port' | translate}}
                          </div>
                        </div>
                        <div class="col-9 py-1">
                          <input type="text" class="form-control" formControlName="v1_remote_port"
                            pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                            placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.remote_port' | translate}}"
                            required
                            [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value || !addSnmpV1v2FormGroup.get('v1_traps_enabled').value ? '' : null">
                          <div
                            *ngIf="addSnmpV1v2FormGroup.get('v1_traps_enabled').value && (addSnmpV1v2FormGroup.get('v1_remote_port').invalid && addSnmpV1v2FormGroup.get('v1_remote_port').dirty || addSnmpV1v2FormGroup.get('v1_remote_port').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v1_remote_port').touched && addSnmpV1v2FormGroup.get('v1_remote_port').errors?.required">
                              {{'log_forward.sys_log.errors.requiredPort' | translate}}
                            </span>
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v1_remote_port').touched && addSnmpV1v2FormGroup.get('v1_remote_port').errors?.pattern">
                              {{'log_forward.sys_log.errors.invalidPort' | translate}}
                            </span>
                          </div>
                        </div>

                      </div>
                    </div>
                    <div class="col-6">
                      <div class="row">
                        <!-- v2 Enable -->
                        <div class="col-3 py-1">
                          {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.v2_enabled' | translate}}
                        </div>
                        <div class="col-9 py-1 d-flex align-items-center">
                          <label class="switch switch-pill switch-success mb-0">
                            <input type="checkbox" class="switch-input" checked formControlName="v2_traps_enabled"
                              [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null"
                              (change)="changeTrapsv2ActiveStatus($event)">
                            <span class="switch-slider"></span>
                          </label>
                        </div>

                        <!-- v2 Local Port-->
                        <div class="col-3 py-1">
                          <div class="mt-1">
                            {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.local_port' | translate}}
                          </div>
                        </div>
                        <div class="col-9 py-1">
                          <input type="text" class="form-control" formControlName="v2_local_port"
                            pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                            placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.local_port' | translate}}"
                            required
                            [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value || !addSnmpV1v2FormGroup.get('v2_traps_enabled').value ? '' : null">
                          <div
                            *ngIf="addSnmpV1v2FormGroup.get('v2_traps_enabled').value && (addSnmpV1v2FormGroup.get('v2_local_port').invalid && addSnmpV1v2FormGroup.get('v2_local_port').dirty || addSnmpV1v2FormGroup.get('v2_local_port').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v2_local_port').touched && addSnmpV1v2FormGroup.get('v2_local_port').errors?.required">
                              {{'log_forward.sys_log.errors.requiredPort' | translate}}
                            </span>
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v2_local_port').touched && addSnmpV1v2FormGroup.get('v2_local_port').errors?.pattern">
                              {{'log_forward.sys_log.errors.invalidPort' | translate}}
                            </span>
                          </div>
                        </div>

                        <!-- v2 Remote Port-->
                        <div class="col-3 py-1">
                          <div class="mt-1">
                            {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.remote_port' | translate}}
                          </div>
                        </div>
                        <div class="col-9 py-1">
                          <input type="text" class="form-control" formControlName="v2_remote_port"
                            pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                            placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.remote_port' | translate}}"
                            required
                            [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value || !addSnmpV1v2FormGroup.get('v2_traps_enabled').value ? '' : null">
                          <div
                            *ngIf="addSnmpV1v2FormGroup.get('v2_traps_enabled').value && (addSnmpV1v2FormGroup.get('v2_remote_port').invalid && addSnmpV1v2FormGroup.get('v2_remote_port').dirty || addSnmpV1v2FormGroup.get('v2_remote_port').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v2_remote_port').touched && addSnmpV1v2FormGroup.get('v2_remote_port').errors?.required">
                              {{'log_forward.sys_log.errors.requiredPort' | translate}}
                            </span>
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV1v2FormGroup.get('v2_remote_port').touched && addSnmpV1v2FormGroup.get('v2_remote_port').errors?.pattern">
                              {{'log_forward.sys_log.errors.invalidPort' | translate}}
                            </span>
                          </div>
                        </div>

                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- SNMP Events -->

            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.snmp_events.title' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <div *ngFor="let snmpEvent of snmpEvents; let i = index" class="form-check py-1 col-3">
                      <input class="form-check-input" type="checkbox" [id]="snmpEvent.label + '_' + i"
                        [checked]="addSnmpV1v2FormGroup.get('snmp_events').value.includes(snmpEvent.value)"
                        (change)="changeSnmpEvent($event, snmpEvent, 'addSnmpV1v2FormGroup')"
                        [attr.disabled]="!addSnmpV1v2FormGroup.get('enable').value ? '' : null">
                      <label class="form-check-label" [for]="snmpEvent.label + '_' + i">
                        {{snmpEvent.label}}
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' |
            translate}}</button>
          <button type="submit" class="btn btn-success">{{'common.save' | translate}}</button>
        </div>
      </div>
    </form>
  </ng-template>

  <!-- Add/update SNMP Host -->
  <ng-template #addSnmpv1v2HostModal let-modal>
    <form [formGroup]="addSnmpV1v2HostFormGroup">
      <div>
        <div class="modal-header">
          <h4 class="modal-title" id="modal-add-snmp-v1-v2-host">
            {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.add_snmp_host.title' | translate }}</h4>
          <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div class="row">
            <!-- IP Address -->
            <div class="col-3 py-1">
              <div class="mt-1">
                {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.ip_address' | translate}}
              </div>
            </div>
            <div class="col-9 py-1">
              <input type="text" class="form-control" formControlName="ip_address"
                placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.ip_address' | translate}}"
                required />
              <div
                *ngIf="addSnmpV1v2HostFormGroup.get('ip_address').invalid && addSnmpV1v2HostFormGroup.get('ip_address').dirty || addSnmpV1v2HostFormGroup.get('ip_address').touched">
                <span class="form-text text-danger"
                  *ngIf="addSnmpV1v2HostFormGroup.get('ip_address').touched && addSnmpV1v2HostFormGroup.get('ip_address').errors?.required">
                  {{'log_forward.snmp.errors.requiredIpAddress' | translate}}
                </span>
                <span class="form-text text-danger"
                  *ngIf="addSnmpV1v2HostFormGroup.get('ip_address').touched && addSnmpV1v2HostFormGroup.get('ip_address').errors?.invalidIpv4">
                  {{'log_forward.snmp.errors.invalidIpAddress' | translate}}
                </span>
              </div>
            </div>

            <!-- Netmask -->
            <div class="col-3 py-1">
              <div class="mt-1">
                {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.netmask' | translate}}
              </div>
            </div>
            <div class="col-9 py-1">
              <input type="text" class="form-control" formControlName="netmask"
                placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.netmask' | translate}}"
                required />
              <div
                *ngIf="addSnmpV1v2HostFormGroup.get('netmask').invalid && addSnmpV1v2HostFormGroup.get('netmask').dirty || addSnmpV1v2HostFormGroup.get('netmask').touched">
                <span class="form-text text-danger"
                  *ngIf="addSnmpV1v2HostFormGroup.get('netmask').touched && addSnmpV1v2HostFormGroup.get('netmask').errors?.required">{{'log_forward.snmp.errors.requiredNetmask'
                  | translate}}</span>
                <span class="form-text text-danger"
                  *ngIf="addSnmpV1v2HostFormGroup.get('netmask').touched && (addSnmpV1v2HostFormGroup.get('netmask').errors?.min || addSnmpV1v2HostFormGroup.get('netmask').errors?.max)">
                  {{'log_forward.snmp.errors.invalidNetmask' | translate}}
                </span>
              </div>
            </div>

            <!-- Accept queries -->
            <div class="col-3 py-1">
              {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.accept_queries' | translate}}
            </div>
            <div class="col-9 py-1 d-flex align-items-center">
              <label class="switch switch-pill switch-success mb-0">
                <input type="checkbox" class="switch-input" checked formControlName="accept_queries">
                <span class="switch-slider"></span>
              </label>
            </div>

            <!-- Send traps -->
            <div class="col-3 py-1">
              {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.send_traps' | translate}}
            </div>
            <div class="col-9 py-1 d-flex align-items-center">
              <label class="switch switch-pill switch-success mb-0">
                <input type="checkbox" class="switch-input" checked formControlName="send_traps">
                <span class="switch-slider"></span>
              </label>
            </div>

          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' |
            translate}}</button>
          <button type="button" class="btn btn-success" (click)="modal.close('Save')">{{'common.save' |
            translate}}</button>
        </div>
      </div>
    </form>
  </ng-template>

  <!-- Confirm delete SNMP Host -->
  <ng-template #deleteSnmpv1v2HostModal let-modal>
    <form [formGroup]="addSnmpV1v2HostFormGroup">
      <div>
        <div class="modal-header">
          <h4 class="modal-title" id="modal-delete-snmp-v1-v2-host">
            {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.delete_snmp_host.title' | translate }}</h4>
          <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.delete_snmp_host.message' | translate}}</div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' |
            translate}}</button>
          <button type="button" class="btn btn-success" (click)="modal.close('Delete')">{{'common.delete' |
            translate}}</button>
        </div>
      </div>
    </form>
  </ng-template>

  <!-- Confirm delete SNMP Community -->
  <ng-template #deleteSnmpv1v2Modal let-modal>
    <form [formGroup]="addSnmpV1v2FormGroup">
      <div>
        <div class="modal-header">
          <h4 class="modal-title" id="modal-delete-snmp-v1-v2">
            {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.delete_snmp_community.title' | translate }}</h4>
          <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.delete_snmp_community.message' | translate}}</div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' |
            translate}}</button>
          <button type="button" class="btn btn-success" (click)="modal.close('Delete')">{{'common.delete' |
            translate}}</button>
        </div>
      </div>
    </form>
  </ng-template>

  <!-- Add/update SNMP Community v3 -->
  <ng-template #addSnmpv3Modal let-modal>
    <form [formGroup]="addSnmpV3FormGroup" (ngSubmit)="saveSnmpV3Setting(modal)">
      <div>
        <div class="modal-header">
          <h4 class="modal-title" id="modal-add-snmp-v3">{{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.title' |
            translate }}</h4>
          <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body" style="max-height: calc(100vh - 200px); overflow-y: auto">
          <div class="row">
            <!-- Community Name -->
            <div class="col-3 py-1">
              <div class="mt-1">
                {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.community_name' | translate}}
              </div>
            </div>
            <div class="col-9 py-1">
              <input type="text" class="form-control" formControlName="community_name" pattern="^\w+$"
                placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.community_name' | translate}}"
                required />
              <div
                *ngIf="addSnmpV3FormGroup.get('community_name').invalid && addSnmpV3FormGroup.get('community_name').dirty || addSnmpV3FormGroup.get('community_name').touched">
                <span class="form-text text-danger"
                  *ngIf="addSnmpV3FormGroup.get('community_name').touched && addSnmpV3FormGroup.get('community_name').errors?.required">
                  {{'log_forward.snmp.errors.requiredCommunityName' | translate}}
                </span>
                <span class="form-text text-danger"
                  *ngIf="addSnmpV3FormGroup.get('community_name').touched && addSnmpV3FormGroup.get('community_name').errors?.pattern">
                  {{'log_forward.snmp.errors.invalidCommunityName' | translate}}
                </span>
              </div>
            </div>
            <!-- Enable -->
            <div class="col-3 py-1">
              {{'log_forward.snmp.config_status' | translate}}
            </div>
            <div class="col-9 py-1 d-flex align-items-center">
              <label class="switch switch-pill switch-success mb-0">
                <input type="checkbox" class="switch-input" checked formControlName="enable"
                  (change)="changeCommunityV3ActiveStatus($event)">
                <span class="switch-slider"></span>
              </label>
            </div>
            <!-- Hosts -->
            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.title' | translate}}
                  <div class="card-header-actions">
                    <button type="button" class="btn btn-primary"
                      [attr.disabled]="!addSnmpV3FormGroup.get('enable').value ? '' : null"
                      (click)="openAddSnmpHost(addSnmpv1v2HostModal)">{{'log_forward.snmp.add' | translate}}</button>
                  </div>
                </div>
                <div class="card-body">
                  <table class="table table-bordered table-sort-icon">
                    <thead>
                      <tr>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.ip_address' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.netmask' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.host_type' | translate}}</th>
                        <th>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.hosts.actions' | translate}}</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr *ngFor="let host of addSnmpV3FormGroup.get('hosts').value; let hostIdx = index">
                        <td>{{host.ip_address}}</td>
                        <td>{{host.netmask}}</td>
                        <td class="text-center">
                          <button type="button"
                            [class]="!!host.accept_queries ? 'btn btn-sm btn-info' : 'btn btn-sm btn-secondary'">
                            Accept queries
                          </button>
                          <button type="button"
                            [class]="!!host.send_traps ? 'btn btn-sm btn-info' : 'btn btn-sm btn-secondary'">
                            Send traps
                          </button>
                        </td>
                        <td class="text-center">
                          <button type="button" class="btn btn-sm btn-info"
                            [attr.disabled]="!addSnmpV3FormGroup.get('enable').value ? '' : null"
                            (click)="openEditSnmpHost(addSnmpv1v2HostModal, host, hostIdx)">{{'log_forward.snmp.edit' |
                            translate}}</button>
                          <button type="button" class="btn btn-sm btn-danger"
                            [attr.disabled]="!addSnmpV3FormGroup.get('enable').value ? '' : null"
                            (click)="deleteSnmpHost(deleteSnmpv1v2HostModal, hostIdx)">{{'log_forward.snmp.delete' |
                            translate}}</button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
            </div>
            <!-- Security Level -->
            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.security_level.title' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <!-- Authentication -->
                    <div class="col-3 py-1">
                      <input class="form-check-input ml-0" type="checkbox" formControlName="authentication_enabled"
                        [attr.disabled]="!addSnmpV3FormGroup.get('enable').value ? '' : null"
                        (change)="changeAuthenStatus($event)" id="authentication_field">
                      <label class="form-check-label ml-4" for="authentication_field">
                        {{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.security_level.authentication' | translate}}
                      </label>
                    </div>
                    <div class="col-9 py-1">
                      <div class="row">
                        <div class="col-6">
                          <select class="form-control" formControlName="authentication_algorithm" required
                            [attr.disabled]="(!addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('authentication_enabled').value) ? '' : null">
                            <option *ngFor="let type of AUTHEN_ALGOS;" value="{{type.value}}">{{type.label}}</option>
                          </select>
                          <div
                            *ngIf="addSnmpV3FormGroup.get('authentication_enabled').value && addSnmpV3FormGroup.get('enable').value && (addSnmpV3FormGroup.get('authentication_algorithm').invalid && addSnmpV3FormGroup.get('authentication_algorithm').dirty || addSnmpV3FormGroup.get('authentication_algorithm').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV3FormGroup.get('authentication_algorithm').touched && addSnmpV3FormGroup.get('authentication_algorithm').errors?.required">
                              {{'log_forward.snmp.errors.requiredAuthenAlgo' | translate}}
                            </span>
                          </div>
                        </div>
                        <div class="col-6">
                          <input type="text" class="form-control" formControlName="authentication_password"
                            placeholder="{{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.security_level.authentication_password' | translate}}"
                            [attr.disabled]="(!addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('authentication_enabled').value) ? '' : null"
                            required />
                          <div
                            *ngIf="addSnmpV3FormGroup.get('authentication_enabled').value && addSnmpV3FormGroup.get('enable').value && (addSnmpV3FormGroup.get('authentication_password').invalid && addSnmpV3FormGroup.get('authentication_password').dirty || addSnmpV3FormGroup.get('authentication_password').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV3FormGroup.get('authentication_password').touched && addSnmpV3FormGroup.get('authentication_password').errors?.required">
                              {{'log_forward.snmp.errors.requiredAuthenPass' | translate}}
                            </span>
                          </div>
                        </div>
                      </div>
                    </div>

                    <!-- Private -->
                    <div class="col-3 py-1">
                      <input class="form-check-input ml-0" type="checkbox" formControlName="private_enabled"
                        (change)="changePrivateStatus($event)"
                        [attr.disabled]="!addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('authentication_enabled').value ? '' : null"
                        id="private_field">
                      <label class="form-check-label ml-4" for="private_field">
                        {{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.security_level.private' | translate}}
                      </label>
                    </div>
                    <div class="col-9 py-1">
                      <div class="row">
                        <div class="col-6">
                          <select class="form-control" formControlName="private_protocol" required
                            [attr.disabled]="(!addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('authentication_enabled').value || !addSnmpV3FormGroup.get('private_enabled').value) ? '' : null">
                            <option *ngFor="let type of PRIVATE_PROTOCOLS;" value="{{type.value}}">{{type.label}}
                            </option>
                          </select>
                          <div
                            *ngIf="addSnmpV3FormGroup.get('private_enabled').value && addSnmpV3FormGroup.get('authentication_enabled').value && addSnmpV3FormGroup.get('enable').value && (addSnmpV3FormGroup.get('private_protocol').invalid && addSnmpV3FormGroup.get('private_protocol').dirty || addSnmpV3FormGroup.get('private_protocol').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV3FormGroup.get('private_protocol').touched && addSnmpV3FormGroup.get('private_protocol').errors?.required">
                              {{'log_forward.snmp.errors.requiredPrivateProtocol' | translate}}
                            </span>
                          </div>
                        </div>
                        <div class="col-6">
                          <input type="text" class="form-control" formControlName="private_password"
                            placeholder="{{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.security_level.private_password' | translate}}"
                            [attr.disabled]="(!addSnmpV3FormGroup.get('private_enabled').value || !addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('authentication_enabled').value) ? '' : null"
                            required />
                          <div
                            *ngIf="addSnmpV3FormGroup.get('private_enabled').value && addSnmpV3FormGroup.get('authentication_enabled').value && addSnmpV3FormGroup.get('enable').value && (addSnmpV3FormGroup.get('private_password').invalid && addSnmpV3FormGroup.get('private_password').dirty || addSnmpV3FormGroup.get('private_password').touched)">
                            <span class="form-text text-danger"
                              *ngIf="addSnmpV3FormGroup.get('private_password').touched && addSnmpV3FormGroup.get('private_password').errors?.required">
                              {{'log_forward.snmp.errors.requiredPrivatePass' | translate}}
                            </span>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- Queries -->
            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.title' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <!-- Enable -->
                    <div class="col-3 py-1">
                      {{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.queries.enabled' | translate}}
                    </div>
                    <div class="col-9 py-1 d-flex align-items-center">
                      <label class="switch switch-pill switch-success mb-0">
                        <input type="checkbox" class="switch-input" checked formControlName="queries_enabled"
                          [attr.disabled]="!addSnmpV3FormGroup.get('enable').value ? '' : null"
                          (change)="changeQueriesActiveStatus($event)" />
                        <span class="switch-slider"></span>
                      </label>
                    </div>
                    <!-- Port-->
                    <div class="col-3 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.port' | translate}}
                      </div>
                    </div>
                    <div class="col-9 py-1">
                      <input type="text" class="form-control" formControlName="port"
                        pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                        placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.queries.port' | translate}}"
                        required
                        [attr.disabled]="!addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('queries_enabled').value ? '' : null">
                      <div
                        *ngIf="addSnmpV3FormGroup.get('queries_enabled').value && (addSnmpV3FormGroup.get('port').invalid && addSnmpV3FormGroup.get('port').dirty || addSnmpV3FormGroup.get('port').touched)">
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV3FormGroup.get('port').touched && addSnmpV3FormGroup.get('port').errors?.required">
                          {{'log_forward.sys_log.errors.requiredPort' | translate}}
                        </span>
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV3FormGroup.get('port').touched && addSnmpV3FormGroup.get('port').errors?.pattern">
                          {{'log_forward.sys_log.errors.invalidPort' | translate}}
                        </span>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- Traps -->
            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.title' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <!-- Enable -->
                    <div class="col-3 py-1">
                      {{'log_forward.snmp.snmp_v3.add_snmp_v3_dialog.traps.enabled' | translate}}
                    </div>
                    <div class="col-9 py-1 d-flex align-items-center">
                      <label class="switch switch-pill switch-success mb-0">
                        <input type="checkbox" class="switch-input" checked formControlName="traps_enabled"
                          [attr.disabled]="!addSnmpV3FormGroup.get('enable').value ? '' : null"
                          (change)="changeTrapsActiveStatus($event)">
                        <span class="switch-slider"></span>
                      </label>
                    </div>

                    <!-- Local Port-->
                    <div class="col-3 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.local_port' | translate}}
                      </div>
                    </div>
                    <div class="col-9 py-1">
                      <input type="text" class="form-control" formControlName="local_port"
                        pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                        placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.local_port' | translate}}"
                        required
                        [attr.disabled]="!addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('traps_enabled').value ? '' : null">
                      <div
                        *ngIf="addSnmpV3FormGroup.get('traps_enabled').value && (addSnmpV3FormGroup.get('local_port').invalid && addSnmpV3FormGroup.get('local_port').dirty || addSnmpV3FormGroup.get('local_port').touched)">
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV3FormGroup.get('local_port').touched && addSnmpV3FormGroup.get('local_port').errors?.required">
                          {{'log_forward.sys_log.errors.requiredPort' | translate}}
                        </span>
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV3FormGroup.get('local_port').touched && addSnmpV3FormGroup.get('local_port').errors?.pattern">
                          {{'log_forward.sys_log.errors.invalidPort' | translate}}
                        </span>
                      </div>
                    </div>

                    <!-- Remote Port-->
                    <div class="col-3 py-1">
                      <div class="mt-1">
                        {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.remote_port' | translate}}
                      </div>
                    </div>
                    <div class="col-9 py-1">
                      <input type="text" class="form-control" formControlName="remote_port"
                        pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                        placeholder="{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.traps.remote_port' | translate}}"
                        required
                        [attr.disabled]="!addSnmpV3FormGroup.get('enable').value || !addSnmpV3FormGroup.get('traps_enabled').value ? '' : null">
                      <div
                        *ngIf="addSnmpV3FormGroup.get('traps_enabled').value && (addSnmpV3FormGroup.get('remote_port').invalid && addSnmpV3FormGroup.get('remote_port').dirty || addSnmpV3FormGroup.get('remote_port').touched)">
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV3FormGroup.get('remote_port').touched && addSnmpV3FormGroup.get('remote_port').errors?.required">
                          {{'log_forward.sys_log.errors.requiredPort' | translate}}
                        </span>
                        <span class="form-text text-danger"
                          *ngIf="addSnmpV3FormGroup.get('remote_port').touched && addSnmpV3FormGroup.get('remote_port').errors?.pattern">
                          {{'log_forward.sys_log.errors.invalidPort' | translate}}
                        </span>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- SNMP Events -->

            <div class="col-12 py-1">
              <div class="card p-0">
                <div class="card-header">
                  {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.snmp_events.title' | translate}}
                </div>
                <div class="card-body">
                  <div class="row">
                    <div *ngFor="let snmpEvent of snmpEvents; let i = index" class="form-check py-1 col-3">
                      <input class="form-check-input" type="checkbox" [id]="snmpEvent.label + '_' + i"
                        [checked]="addSnmpV3FormGroup.get('snmp_events').value.includes(snmpEvent.value)"
                        (change)="changeSnmpEvent($event, snmpEvent, 'addSnmpV3FormGroup')"
                        [attr.disabled]="!addSnmpV3FormGroup.get('enable').value ? '' : null">
                      <label class="form-check-label" [for]="snmpEvent.label + '_' + i">
                        {{snmpEvent.label}}
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' |
            translate}}</button>
          <button type="submit" class="btn btn-success">{{'common.save' | translate}}</button>
        </div>
      </div>
    </form>
  </ng-template>

  <!-- Confirm delete SNMP Community v3 -->
  <ng-template #deleteSnmpv3Modal let-modal>
    <div>
      <div class="modal-header">
        <h4 class="modal-title" id="modal-delete-snmp-v3">
          {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.delete_snmp_community.title' | translate }}</h4>
        <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <div>{{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.delete_snmp_community.message' | translate}}</div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" (click)="modal.close('Close')">{{'common.close' |
          translate}}</button>
        <button type="button" class="btn btn-success" (click)="modal.close('Delete')">{{'common.delete' |
          translate}}</button>
      </div>
    </div>
  </ng-template>

</div>